# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.AndroidEnterprise.V1.Model.AppState do
  @moduledoc """
  List of states set by the app.

  ## Attributes

  *   `keyedAppState` (*type:* `list(GoogleApi.AndroidEnterprise.V1.Model.KeyedAppState.t)`, *default:* `nil`) - List of keyed app states. This field will always be present.
  *   `packageName` (*type:* `String.t`, *default:* `nil`) - The package name of the app. This field will always be present.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :keyedAppState => list(GoogleApi.AndroidEnterprise.V1.Model.KeyedAppState.t()) | nil,
          :packageName => String.t() | nil
        }

  field(:keyedAppState, as: GoogleApi.AndroidEnterprise.V1.Model.KeyedAppState, type: :list)
  field(:packageName)
end

defimpl Poison.Decoder, for: GoogleApi.AndroidEnterprise.V1.Model.AppState do
  def decode(value, options) do
    GoogleApi.AndroidEnterprise.V1.Model.AppState.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.AndroidEnterprise.V1.Model.AppState do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
