# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.AndroidEnterprise.V1.Model.DeviceReport do
  @moduledoc """
  Device report updated with the latest app states for managed apps on the device.

  ## Attributes

  *   `appState` (*type:* `list(GoogleApi.AndroidEnterprise.V1.Model.AppState.t)`, *default:* `nil`) - List of app states set by managed apps on the device. App states are defined by the app's developers. This field will always be present.
  *   `lastUpdatedTimestampMillis` (*type:* `String.t`, *default:* `nil`) - The timestamp of the last report update in milliseconds since epoch. This field will always be present.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :appState => list(GoogleApi.AndroidEnterprise.V1.Model.AppState.t()) | nil,
          :lastUpdatedTimestampMillis => String.t() | nil
        }

  field(:appState, as: GoogleApi.AndroidEnterprise.V1.Model.AppState, type: :list)
  field(:lastUpdatedTimestampMillis)
end

defimpl Poison.Decoder, for: GoogleApi.AndroidEnterprise.V1.Model.DeviceReport do
  def decode(value, options) do
    GoogleApi.AndroidEnterprise.V1.Model.DeviceReport.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.AndroidEnterprise.V1.Model.DeviceReport do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
