# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.AndroidEnterprise.V1.Model.InstallFailureEvent do
  @moduledoc """
  An event generated when an app installation failed on a device

  ## Attributes

  *   `deviceId` (*type:* `String.t`, *default:* `nil`) - The Android ID of the device. This field will always be present.
  *   `failureDetails` (*type:* `String.t`, *default:* `nil`) - Additional details on the failure if applicable.
  *   `failureReason` (*type:* `String.t`, *default:* `nil`) - The reason for the installation failure. This field will always be present.
  *   `productId` (*type:* `String.t`, *default:* `nil`) - The id of the product (e.g. "app:com.google.android.gm") for which the install failure event occured. This field will always be present.
  *   `userId` (*type:* `String.t`, *default:* `nil`) - The ID of the user. This field will always be present.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :deviceId => String.t() | nil,
          :failureDetails => String.t() | nil,
          :failureReason => String.t() | nil,
          :productId => String.t() | nil,
          :userId => String.t() | nil
        }

  field(:deviceId)
  field(:failureDetails)
  field(:failureReason)
  field(:productId)
  field(:userId)
end

defimpl Poison.Decoder, for: GoogleApi.AndroidEnterprise.V1.Model.InstallFailureEvent do
  def decode(value, options) do
    GoogleApi.AndroidEnterprise.V1.Model.InstallFailureEvent.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.AndroidEnterprise.V1.Model.InstallFailureEvent do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
