# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.AndroidEnterprise.V1.Model.ManagedConfiguration do
  @moduledoc """
  A managed configuration resource contains the set of managed properties defined by the app developer in the app's managed configurations schema, as well as any configuration variables defined for the user.

  ## Attributes

  *   `configurationVariables` (*type:* `GoogleApi.AndroidEnterprise.V1.Model.ConfigurationVariables.t`, *default:* `nil`) - Contains the ID of the managed configuration profile and the set of configuration variables (if any) defined for the user.
  *   `kind` (*type:* `String.t`, *default:* `nil`) - Deprecated.
  *   `managedProperty` (*type:* `list(GoogleApi.AndroidEnterprise.V1.Model.ManagedProperty.t)`, *default:* `nil`) - The set of managed properties for this configuration.
  *   `productId` (*type:* `String.t`, *default:* `nil`) - The ID of the product that the managed configuration is for, e.g. "app:com.google.android.gm".
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :configurationVariables =>
            GoogleApi.AndroidEnterprise.V1.Model.ConfigurationVariables.t() | nil,
          :kind => String.t() | nil,
          :managedProperty =>
            list(GoogleApi.AndroidEnterprise.V1.Model.ManagedProperty.t()) | nil,
          :productId => String.t() | nil
        }

  field(:configurationVariables, as: GoogleApi.AndroidEnterprise.V1.Model.ConfigurationVariables)
  field(:kind)
  field(:managedProperty, as: GoogleApi.AndroidEnterprise.V1.Model.ManagedProperty, type: :list)
  field(:productId)
end

defimpl Poison.Decoder, for: GoogleApi.AndroidEnterprise.V1.Model.ManagedConfiguration do
  def decode(value, options) do
    GoogleApi.AndroidEnterprise.V1.Model.ManagedConfiguration.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.AndroidEnterprise.V1.Model.ManagedConfiguration do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
