# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.AndroidEnterprise.V1.Model.ManagedConfigurationsSettings do
  @moduledoc """
  A managed configurations settings resource contains the set of managed properties that have been configured for an Android app to be applied to a set of users. The app's developer would have defined configurable properties in the managed configurations schema.

  ## Attributes

  *   `lastUpdatedTimestampMillis` (*type:* `String.t`, *default:* `nil`) - The last updated time of the managed configuration settings in milliseconds since 1970-01-01T00:00:00Z.
  *   `mcmId` (*type:* `String.t`, *default:* `nil`) - The ID of the managed configurations settings.
  *   `name` (*type:* `String.t`, *default:* `nil`) - The name of the managed configurations settings.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :lastUpdatedTimestampMillis => String.t() | nil,
          :mcmId => String.t() | nil,
          :name => String.t() | nil
        }

  field(:lastUpdatedTimestampMillis)
  field(:mcmId)
  field(:name)
end

defimpl Poison.Decoder, for: GoogleApi.AndroidEnterprise.V1.Model.ManagedConfigurationsSettings do
  def decode(value, options) do
    GoogleApi.AndroidEnterprise.V1.Model.ManagedConfigurationsSettings.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.AndroidEnterprise.V1.Model.ManagedConfigurationsSettings do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
