# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.AndroidEnterprise.V1.Model.NewPermissionsEvent do
  @moduledoc """
  An event generated when new permissions are added to an app.

  ## Attributes

  *   `approvedPermissions` (*type:* `list(String.t)`, *default:* `nil`) - The set of permissions that the enterprise admin has already approved for this application. Use Permissions.Get on the EMM API to retrieve details about these permissions.
  *   `productId` (*type:* `String.t`, *default:* `nil`) - The id of the product (e.g. "app:com.google.android.gm") for which new permissions were added. This field will always be present.
  *   `requestedPermissions` (*type:* `list(String.t)`, *default:* `nil`) - The set of permissions that the app is currently requesting. Use Permissions.Get on the EMM API to retrieve details about these permissions.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :approvedPermissions => list(String.t()) | nil,
          :productId => String.t() | nil,
          :requestedPermissions => list(String.t()) | nil
        }

  field(:approvedPermissions, type: :list)
  field(:productId)
  field(:requestedPermissions, type: :list)
end

defimpl Poison.Decoder, for: GoogleApi.AndroidEnterprise.V1.Model.NewPermissionsEvent do
  def decode(value, options) do
    GoogleApi.AndroidEnterprise.V1.Model.NewPermissionsEvent.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.AndroidEnterprise.V1.Model.NewPermissionsEvent do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
