# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.AndroidEnterprise.V1.Model.PageInfo do
  @moduledoc """
  Information about the current page. List operations that supports paging return only one "page" of results. This protocol buffer message describes the page that has been returned.

  ## Attributes

  *   `resultPerPage` (*type:* `integer()`, *default:* `nil`) - Maximum number of results returned in one page. ! The number of results included in the API response.
  *   `startIndex` (*type:* `integer()`, *default:* `nil`) - Index of the first result returned in the current page.
  *   `totalResults` (*type:* `integer()`, *default:* `nil`) - Total number of results available on the backend ! The total number of results in the result set.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :resultPerPage => integer() | nil,
          :startIndex => integer() | nil,
          :totalResults => integer() | nil
        }

  field(:resultPerPage)
  field(:startIndex)
  field(:totalResults)
end

defimpl Poison.Decoder, for: GoogleApi.AndroidEnterprise.V1.Model.PageInfo do
  def decode(value, options) do
    GoogleApi.AndroidEnterprise.V1.Model.PageInfo.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.AndroidEnterprise.V1.Model.PageInfo do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
