# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.AndroidEnterprise.V1.Model.ProductsListResponse do
  @moduledoc """


  ## Attributes

  *   `pageInfo` (*type:* `GoogleApi.AndroidEnterprise.V1.Model.PageInfo.t`, *default:* `nil`) - General pagination information.
  *   `product` (*type:* `list(GoogleApi.AndroidEnterprise.V1.Model.Product.t)`, *default:* `nil`) - Information about a product (e.g. an app) in the Google Play store, for display to an enterprise admin.
  *   `tokenPagination` (*type:* `GoogleApi.AndroidEnterprise.V1.Model.TokenPagination.t`, *default:* `nil`) - Pagination information for token pagination.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :pageInfo => GoogleApi.AndroidEnterprise.V1.Model.PageInfo.t() | nil,
          :product => list(GoogleApi.AndroidEnterprise.V1.Model.Product.t()) | nil,
          :tokenPagination => GoogleApi.AndroidEnterprise.V1.Model.TokenPagination.t() | nil
        }

  field(:pageInfo, as: GoogleApi.AndroidEnterprise.V1.Model.PageInfo)
  field(:product, as: GoogleApi.AndroidEnterprise.V1.Model.Product, type: :list)
  field(:tokenPagination, as: GoogleApi.AndroidEnterprise.V1.Model.TokenPagination)
end

defimpl Poison.Decoder, for: GoogleApi.AndroidEnterprise.V1.Model.ProductsListResponse do
  def decode(value, options) do
    GoogleApi.AndroidEnterprise.V1.Model.ProductsListResponse.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.AndroidEnterprise.V1.Model.ProductsListResponse do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
