# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.AndroidEnterprise.V1.Model.SignupInfo do
  @moduledoc """
  A resource returned by the GenerateSignupUrl API, which contains the Signup URL and Completion Token.

  ## Attributes

  *   `completionToken` (*type:* `String.t`, *default:* `nil`) - An opaque token that will be required, along with the Enterprise Token, for obtaining the enterprise resource from CompleteSignup.
  *   `kind` (*type:* `String.t`, *default:* `nil`) - Deprecated.
  *   `url` (*type:* `String.t`, *default:* `nil`) - A URL under which the Admin can sign up for an enterprise. The page pointed to cannot be rendered in an iframe.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :completionToken => String.t() | nil,
          :kind => String.t() | nil,
          :url => String.t() | nil
        }

  field(:completionToken)
  field(:kind)
  field(:url)
end

defimpl Poison.Decoder, for: GoogleApi.AndroidEnterprise.V1.Model.SignupInfo do
  def decode(value, options) do
    GoogleApi.AndroidEnterprise.V1.Model.SignupInfo.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.AndroidEnterprise.V1.Model.SignupInfo do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
