# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.AndroidEnterprise.V1.Model.StoreCluster do
  @moduledoc """
  Definition of a managed Google Play store cluster, a list of products displayed as part of a store page.

  ## Attributes

  *   `id` (*type:* `String.t`, *default:* `nil`) - Unique ID of this cluster. Assigned by the server. Immutable once assigned.
  *   `name` (*type:* `list(GoogleApi.AndroidEnterprise.V1.Model.LocalizedText.t)`, *default:* `nil`) - Ordered list of localized strings giving the name of this page. The text displayed is the one that best matches the user locale, or the first entry if there is no good match. There needs to be at least one entry.
  *   `orderInPage` (*type:* `String.t`, *default:* `nil`) - String (US-ASCII only) used to determine order of this cluster within the parent page's elements. Page elements are sorted in lexicographic order of this field. Duplicated values are allowed, but ordering between elements with duplicate order is undefined. The value of this field is never visible to a user, it is used solely for the purpose of defining an ordering. Maximum length is 256 characters.
  *   `productId` (*type:* `list(String.t)`, *default:* `nil`) - List of products in the order they are displayed in the cluster. There should not be duplicates within a cluster.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :id => String.t() | nil,
          :name => list(GoogleApi.AndroidEnterprise.V1.Model.LocalizedText.t()) | nil,
          :orderInPage => String.t() | nil,
          :productId => list(String.t()) | nil
        }

  field(:id)
  field(:name, as: GoogleApi.AndroidEnterprise.V1.Model.LocalizedText, type: :list)
  field(:orderInPage)
  field(:productId, type: :list)
end

defimpl Poison.Decoder, for: GoogleApi.AndroidEnterprise.V1.Model.StoreCluster do
  def decode(value, options) do
    GoogleApi.AndroidEnterprise.V1.Model.StoreCluster.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.AndroidEnterprise.V1.Model.StoreCluster do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
